\chapter{Introduction}\label{ch:introduction}
\paragraph{Motivation}\label{sec:motivation} % todo
Comparing performance metrics of different hardware and software configurations is important to determine the success of different iterations of them both. Duckietown has existed for about four years and constantly been developed further by students, researchers and enthusiasts. During the last years it has seen several different versions of Duckiebot hardware and software and respective production rounds. However, , improvements or even deteriorations were never assessed in an exhaustive manner. Having a common benchmark across different universities is essential to compare among each other.
\paragraph{Benchmark}
Generally a benchmark consists of the following points:
\begin{itemize}
    \item \textbf{Definition of an environment}, this includes hardware, software, a map and environmental conditions. The benchmark happens within said environment as such it has to be defined rigorously in order to ensure reproducibility.
    \item \textbf{Definition of the input}, based on what measurements the benchmark score is calculated. First of all this is the measurements others might include other observations or meta data.
    \item \textbf{Definition of the output}, the performance metric, respectively the scoring of the Duckiebots based on the given input. According to said output performance, strengths and weaknesses are compared. 
\end{itemize}

\paragraph{Relevance}
In order to assess progress of newly created hardware, a common ground on how to compare performance of different hardware needs to be established. The Duckietown community has seen two different major versions of robots and several prototypes of improvements or new concepts have been produced. Of the second major version exist four different production rounds. However, the performance has never been evaluated thoroughly. 
\\
If a correctly assembled Duckiebot shows unexpected behavior, performing a benchmark might indicate the source of the problem as the benchmark is a standardized procedure. Analyzing the scores provides a quick overview which can then be evaluated further until the problem can be localized. 
\\
Before a hardware upgrade, as for example upgrading from the Raspberry Pi 3B+ to the Raspberry Pi 4, it is important to assess the performance in order to evaluate the improvement. 

\paragraph{Challenge}
As seen in J. Baltes \cite{Baltes_suite} it is difficult to develop a benchmark which effectively represents the real-life performance within and keep the benchmark portable and applicable to different sizes and types of mobile robots. Thus, this thesis will limit the benchmark to small, differentially driven, computer-vision based, three- or four-wheeled robots with a limited amount of on-board sensors in the Duckietown environment. The possibility to adapt to smaller changes in the hardware should still be given.
\\
Additionally, the Benchmark should be only minimally invasive, which means only minimal additional software is required in order to run. The obstacle to run a benchmark should thus be as small as possible. This will facilitate the collection of large amounts of data. 

\paragraph{Previous work}
In the Duckietown community a benchmark environment has been defined in order to assess the performance of different \textit{software} configurations \cite{llingg}. Since a benchmark for software needs to be flexible with respect to what is actually tested, its focus is in the first place on setting up a software comparing different scores for a user-defined benchmark-protocol. This protocol has to be adjusted for different software configurations. Measuring the performance of hardware on the other hand needs a standardized procedure to which all users adhere. Nonetheless hard- and software benchmarks are closely related and are closely related on \emph{what} is being measured. The main difference is in the focus of the evaluation. Additionally,  the hardware benchmark doesn't necessarily rely on localization data. 
\\
In order to log the hardware statistics the Duckietown diagnostics were created \cite{dt-diagnostics} which allows to log hard- an software specific measurements. As such it will form the base of the benchmark.

\paragraph{Use case}
The hardware Benchmark can be used, for example, in the following cases:
\begin{itemize}
    \item Assess the performance of new hardware, like new Raspberry Pi 4, new sensors or Ackermann steering in a newer generation of the Duckiebot.
    \item Compare hardware metrics of different software versions. E.g., is lane following using the new lane detector node about as resourceful as the one currently used.
    \item Detect hardware (or even environment) related issues in case a Duckiebot is not running as expected. E.g., constant overheating, under voltage, slow lane detection, due to too many detected lane segments.
\end{itemize}

\paragraph{Method}
In order to measure the performance of a Duckiebot, a protocol has been created. This defines the procedure and setup as well as soft- and hardware configurations. The benchmark is based upon the lane following demo \cite{dt_manual} as well as the diagnostics \cite{dt-diagnostics}. To keep the benchmark as simple as possible, it manages to need minimal setup and adjustments to the Duckiebot. In order to almost completely automate the benchmark, an API, frontend as well as a CLI tool were created.

